// Header File
// Created 04/08/2005; 22:29:15
#ifndef __HAWK_hiscores_H__
#define __HAWK_hiscores_H__

//==========================================================================//

static inline void OuvreFichierSauvegarde(void)
{
	char extension[] = "SAV";
	char signature[] = "HAWKB2";
	
	entry = DerefSym(SymFindMain(SYMSTR("hawksav")));
	
	if (entry != NULL)
	{
		Sauvegarde = (unsigned char *)HLock(entry->handle);
		if (memcmp(Sauvegarde+2, signature, 6) != 0)
		{
			HeapUnlock(entry->handle);
			goto Nouveau;
		}
		mode = *(Sauvegarde+8);
		lives = *(Sauvegarde+9);
		memcpy(hscore, Sauvegarde+10, 70);
	}
	else
	{
	  Nouveau:
		entry = DerefSym(SymAddMain(SYMSTR("hawksav")));
		Sauvegarde = (unsigned char *)HLock(entry->handle = HeapAlloc(86));
		*(unsigned short *)Sauvegarde = 84;
		strcpy(Sauvegarde+2, signature);
		*(Sauvegarde+80) = 0;
		strcpy(Sauvegarde+81, extension);
		*(Sauvegarde+85) = OTH_TAG;
	}
}

//==========================================================================//

static inline void FermeFichierSauvegarde(void)
{
	*(Sauvegarde+8) = mode;
	*(Sauvegarde+9) = lives;
	memcpy(Sauvegarde+10, hscore, 70);
	HeapUnlock(entry->handle);
}

//==========================================================================//

void HiScore(void)
{
	char nom[] = "          ";
	short key, dim, i;
	
	dim = 0;
	
	for(i = 4; hscore[i-1].score < score && (long)i; i --)
	{
		memcpy(&hscore[i], &hscore[i-1], sizeof(HIGH_SCORES)); 
	}
    
	hscore[i].score = score;
	memcpy(hscore[i].nom, nom, sizeof(hscore[i].nom));	// Pour Nounours
	
	TransitionBas();
	RestaureInterruptions();
	GrayOn();
	InitMenu();
	MenuHiscores();
	DrawSPECIAL_String(32+ADAPT_X, 7+ADAPT_Y, "NEW HISCORE!", __L_plane, __D_plane, MODE_REMPLACE);
	DrawSPECIAL_String(16+ADAPT_X, 85+ADAPT_Y, "ENTER YOUR NAME!", __L_plane, __D_plane, MODE_REMPLACE);
	TransitionHaut();
	GKeyFlush();
	
	do
	{
		DrawSPECIAL_String(7+ADAPT_X, 27+12*i+ADAPT_Y, nom, __L_plane, __D_plane, MODE_REMPLACE);
		key = toupper(ngetchx());	// Transforme automatiquement les minuscules en majuscules
		
		if(key >= ' ' && key <= 'Z'  && dim < 10)
		{
			nom[dim ++] = key;
		}
		else if(key == KEY_BACKSPACE && dim > 0)
		{
			nom[-- dim] = ' ';
		}
		else if(key == KEY_CLEAR)
		{
			memset(nom, ' ', 10);
			dim = 0;
		}
		else if(key == KEY_APPS)
		{
			off();
		}
		 
	}while(key != KEY_ENTER);
	
	memcpy(hscore[i].nom, nom, sizeof(hscore[i].nom));
	GrayOff();
	RedirigeInterruptions();
	InitMenu();
	MenuHiscores();
	PressionTouche(TESTE_ET_SORT);	//	Purge le clavier
	EnterEsc();
	PressionTouche(TESTE_ET_SORT);	//	Purge le clavier
}

//==========================================================================//

#endif